
// -*- C++ -*-

// (c) COPYRIGHT URI/MIT 1999
// Please read the full copyright statement in the file COPYRIGHT.
//
// Authors:
//      jhrg,jimg       James Gallagher (jgallagher@gso.uri.edu)

#ifndef _jguint16_h
#define _jguint16_h 1

#ifdef __GNUG__
#pragma interface
#endif

#include "UInt16.h"

class JGUInt16: public UInt16 {
private:
    dods_uint16 _missing_val;

public:
    JGUInt16(const string &n = "");
    virtual ~JGUInt16() {}

    virtual BaseType *ptr_duplicate();
    
    virtual bool read(const string &dataset);

    virtual void set_missing_value(const dods_uint16 &v);

    virtual dods_uint16 get_missing_value() const;
};

// $Log: JGUInt16.h,v $
// Revision 1.4.4.1  2001/08/21 15:14:20  dan
// Updated names of the set/get accessor methods for modifying the missing_value
// member field, to make the naming convention consistent with the current
// DAP usage.
//
// Revision 1.4  2000/10/10 23:36:14  jimg
// Added exception processing code.
// Added throws to the read methods.
// Changed the definition of read to match the dap library.
// Moved CVS Log entries to the end of files.
//
// Revision 1.3  1999/11/05 01:17:24  jimg
// Result of merge with release-3-1-0
//
// Revision 1.2.6.1  1999/10/24 18:30:23  dan
// Modified to support type conversion from JGOFS
// string variables to dods_uint16.
//
// Revision 1.2  1999/05/05 22:57:19  jimg
// Merged Brent's String --> string changes with Dan's changes
//
// Revision 1.1  1999/03/27 01:00:34  jimg
// Added
//

#endif

