//
// DanH 10/21/94

#define HOME_DIR_HACK 1

#include "config_jg.h"

static char rcsid[] not_used ={"$Id: jg_path.cc,v 1.1.2.1 2001/08/21 16:16:08 dan Exp $"};


#include <stdio.h>
#include <stdlib.h>
char *getenv();
#include <unistd.h>
#include <pwd.h>
#include <ctype.h>
#include <string.h>
#include <assert.h>
#include <iostream.h>
#include <string>

#include "cgi_util.h"

#include <sys/stat.h>

int test_path(char* pathname)
{
    struct stat buf;
    int i;

    if ( lstat(pathname,&buf) < 0 ) return 0;
    else {
      if ( S_ISDIR(buf.st_mode) || S_ISLNK(buf.st_mode)) return 1;
      return 0;
    }
}

void
check_jgofs_path(string &relativePath, string &methodPath)
{

/* The HOME_DIR_HACK uses the current machine's /etc/passwd file (or
   whatever getpwnam(3) searches) to find the JGOFS home directory. We
   assume that the jgofs object root directory is a subdir of the home
   dir called `objects'. This seems to be OK to do since the Makefile
   uses and equivalent assumption when it builds the JGOFS API. 10/13/95
   jhrg */

/* HOME_DIR_HACK modified to search for the environment variables
   `JGOFS_OBJECT', and `JGOFS_METHOD' to satisfy the JGOFS dictionary
   search mechanism without requiring an entry in the /etc/passwd file.
   3/1/99 danh */

    //char *object_path, OBJECT_PATH[128];
    string new_object_path = "", new_method_path = "";
    char *object_path, OBJECT_PATH[128];
    char *method_path, METHOD_PATH[128];

#if HOME_DIR_HACK

    struct passwd *pwd_entry;
    struct stat buf;
    bool object_error,method_error;
    string errMessage = "";

    /* No `jgofs' user, OBJECT_PATH, METHOD_PATH must be defined, else exit with error */
    object_path = getenv("JGOFS_OBJECT");
    if ( object_path ) {
       object_error = FALSE;

       new_object_path = object_path + relativePath;   /* append relative directory */
       relativePath = new_object_path;   /* append relative directory */
       if (test_path((char *)new_object_path.c_str()) == 0) {
	 object_error = TRUE;
       }
       else {
	 method_path = getenv("JGOFS_METHOD");
	 if ( method_path ) {
	   method_error = FALSE;

	   new_method_path = method_path;
	   methodPath = new_method_path;   /* append relative directory */

	   if (test_path((char *)new_method_path.c_str()) == 0) {
	     method_error = TRUE;
	   }
	 }
	 else {  /* METHOD_PATH is undefined */
	   method_error = TRUE;
	 }
       }
    }
    else {
      pwd_entry = getpwnam( "jgofs" );	/* assume the name "jgofs" */
      if ( pwd_entry == NULL ) {
        /* OBJECT_PATH is undefined && No `jgofs' user defined. */
        /* check to see if there is a '.objects' file in the    */
	/* current directory.                                   */

	struct stat buf;
	int i;

	if ( lstat(".objects",&buf) < 0 ) object_error = TRUE;
	else {
	  if ( S_ISREG(buf.st_mode)) {
	    object_error = FALSE;

	    if ( method_path = getcwd(METHOD_PATH,128) ) {
	      strcat(method_path,"/");
	      method_error = FALSE;
	    }
	    else 
	      method_error = TRUE;
	  }
	}
      }
      else {  
	
	/* `jgofs' user exists, define OBJECT_PATH, METHOD_PATH relative to home directory */
	object_path = OBJECT_PATH;
	strcpy(object_path, pwd_entry->pw_dir);

	strcat(object_path, "/objects");    /* assume all dictionaries are in subdirs of `objects' */

	if ( relativePath != "") { 
	  strcat(object_path, "/");                  
	  strcat(object_path, relativePath.c_str());  /* append relative_path directory */
	}
	object_error = FALSE;

	if (test_path(object_path) == 0) object_error = TRUE;
	
	relativePath = object_path;   /* update relative_path to complete path */

	method_path = METHOD_PATH;

	strcpy(method_path, pwd_entry->pw_dir);
	strcat(method_path, "/methods/");	/* assume methods are in subdir `methods' */

	method_error = FALSE;

	if (test_path(method_path) == 0) method_error = TRUE;

	methodPath = method_path;
      }
    }
    /*
     * Check for errors in the OBJECT_PATH and METHOD_PATH locations.
     */
    if ( object_error || method_error ) {
      errMessage = "unable to determine JGOFS_OBJECT or JGOFS_METHOD, refer to INSTALL-jgofs";

      ErrMsgT(errMessage);

      throw Error(no_such_file, errMessage);
    }

#else
    /*
     * HOME_DIR_HACK is not set
     */
    object_path = OBJECT_PATH;
    strcpy(object_path, OBJECT_ROOT);	/* original objects */
    strcat(object_path, relativePath.c_str()); /* append relative directory */

    object_error = FALSE;

    if (test_path(object_path) == 0) object_error = TRUE;

    method_path = METHOD_PATH;
    strcpy(method_path, METHOD_ROOT);	/* original method  */

    method_error = FALSE;

    if (test_path(method_path) == 0) method_error = TRUE;

#endif

}
